#!/bin/bash
set -e
echo "$0 preparation script"
pwd

echo "Cleaning ..."
make clean

echo "Compile and install map plugin"
make
ret=$?
mkdir -p /usr/lib/ieee1905
cp libwifimap2.so /usr/lib/ieee1905/

supervisorctl status all
supervisorctl update

echo "Validate map.1905 object not present"
ubus list map.1905
if [ $? -ne 0 ]; then
	echo "PASS: map.1905 not present"
fi

echo "Restarting ieee1905d to load plugin"
supervisorctl restart ieee1905d
sleep 3
supervisorctl status all

echo "Run API validation tests"
ubus-api-validator -d ./test/api/json/ > ./api-result.log
ret=$?

supervisorctl stop all
supervisorctl status

cp ./memory-report.xml ./api-test-memory-report.xml
tap-junit --input ./api-result.log --output report
date +%s > timestamp.log

echo "$0 exit status ${ret}"
exit ${ret}
