#!/bin/bash

echo "install dependencies"

pwd

function exec_cmd()
{
	echo "executing $@"
	$@ >/dev/null 2>&1
	local ret=$?

	if [ "${ret}" -ne 0 ]; then
		echo "Failed to execute $@ ret (${ret})"
		exit 1
	fi
}

mkdir -p /opt/dev/

cd /opt/dev
export CFLAGS="${CFLAGS} -g -Wall -g -O0"
rm -fr ieee1905
exec_cmd git clone --depth 1 -b devel https://dev.iopsys.eu/iopsys/ieee1905.git
cd ieee1905
exec_cmd ./gitlab-ci/install-dependencies.sh
exec_cmd ./gitlab-ci/setup.sh
exec_cmd make "CONFIG_IEEE1905_ALME_OVER_UBUS=y"
exec_cmd make install
mkdir -p /usr/include/ieee1905
exec_cmd cp -a include/plugin.h /usr/include/ieee1905
exec_cmd cp -a ieee1905d /usr/sbin/
