#include <stdarg.h>
#include <stddef.h>
#include <setjmp.h>
#include <cmocka.h>
#include <libubus.h>
#include <libubox/blobmsg_json.h>
#include <libubox/blobmsg.h>
#include <json-c/json.h>

#include <ieee1905/plugin.h>
#include "map2.h"
#include "map_common.h"

extern struct plugin libwifimap2;
static int group_setup(void **state)
{
	return 0;
}

static int test_setup(void **state)
{
	return 0;
}

static int group_teardown(void **state)
{
	return 0;
}

// Stub functions
bool cmdu_dispacher(struct plugin_process_data *pdata)
{
	printf("cmdu_dispacher called");
	return true;
}

void update_module_db(bool set, uint8_t role, uint8_t profile)
{
	printf("update_module_db called");
}

static void test_plugin_name(void **state)
{
	assert_string_equal(libwifimap2.name, "libwifimap2");
}

static void test_tlv_encode_decode(void **state)
{
	struct tlv_al_mac tlv;
	uint8_t *tlv_stream;
	char *tlv_str;
	uint16_t tlv_len = 0;

	// fill the tlv with correct info
	tlv.tlv_type = TLV_TYPE_AL_MAC_ADDRESS_TYPE;
	tlv.al_mac_address[0] = 0x11;
	tlv.al_mac_address[1] = 0x22;
	tlv.al_mac_address[2] = 0x33;
	tlv.al_mac_address[3] = 0x44;
	tlv.al_mac_address[4] = 0x55;
	tlv.al_mac_address[5] = 0x66;

	tlv_stream = map_put_tlv_cstruct((uint8_t *) &tlv, &tlv_len);
	assert_non_null(tlv_stream);

	tlv_str = _btostr(tlv_stream, tlv_len);
	assert_non_null(tlv_str);
	assert_string_equal(tlv_str, "010006112233445566");
	free(tlv_stream);
	free(tlv_str);
}

int main(void)
{
	const struct CMUnitTest tests[] = {
		cmocka_unit_test_setup(test_plugin_name, test_setup),
		cmocka_unit_test_setup(test_tlv_encode_decode, test_setup),
	};

	return cmocka_run_group_tests(tests, group_setup, group_teardown);
}

